#version 330 core

uniform mat4 world_model;
uniform mat4 view_world;
uniform mat4 clip_view;

in vec3 model_position;
in vec2 texture;

out vec2 tex_coords;

void main()
{
   tex_coords = texture;
   gl_Position = clip_view * view_world * world_model * vec4(model_position, 1);
}

###

#version 330 core

struct Material
{
   sampler2D texture;
};

uniform Material material;

in vec2 tex_coords;

out vec4 frag_color;

void main()
{
   frag_color = texture(material.texture, tex_coords);
}